declare
  varLob  clob;

begin
  varLob := 'select
'||'  req_au.req_grp as request_group,
'||'  case
'||'    when req_au.request_num_status is null or req_au.request_num_status in ( ''0'', ''1'' ) then ''Informal request''
'||'    when req_au.request_num_status > ''1'' and req_au.req_parent is not null then ''Child access request''
'||'    when req_au.request_num_status > ''1'' and req_au.request_num_type > 60 and req_au.target_attr2 = ''Review Conflicts'' then ''Conflict review''
'||'    when req_au.request_num_status > ''1'' and req_au.request_num_type > 60 then req_au.target_attr2
'||'    when req_au.request_num_status > ''1'' and req_au.req_parent is null then ''Access request''
'||'    else req_au.req_grp || '' - '' || req_au.target_attr2
'||'  end as request_detail,
'||'  case
'||'    when req_au.req_grp <> req_au.req_id then req_au.req_id
'||'    else req_au.req_grp
'||'  end as request_id,
'||'  req_au.req_created_on request_creation_date,
'||'  ra.code || '' - '' || ra.surname || '' '' || ra.name as request_applicant,
'||'  req_au.request_type,
'||'  req_au.request_status,
'||'  case
'||'    when ro.code = ra.code then null
'||'    when ro.code is not null then ro.code || '' - '' || ro.surname || '' '' || ro.name
'||'  end as request_operator,
'||'  case when rb.code is not null then rb.code || '' - '' || rb.surname || '' '' || rb.name end as request_beneficiary,
'||'  req_au.event_date,
'||'  req_au.obj1_attr3 as entitlement_name,
'||'  req_au.obj1_attr4 as application_name,
'||'  req_au.target_attr5 as realm,
'||'  req_au.event_desc as other_details
'||'from
'||'(
'||'  select
'||'    case
'||'      when sr.parent is null then sr.id
'||'      else sr.parent
'||'    end as req_grp,
'||'    sr.id as req_id,
'||'    sr.parent as req_parent,
'||'    sr.created_on as req_created_on,
'||'    sr.applicant as req_applicant,
'||'    al.operator_code,
'||'    al.cod_operation,
'||'    al.event_date,
'||'    al.target_attr2,
'||'    al.obj1_type,
'||'    al.obj1_key_id,
'||'    al.obj1_key_name,
'||'    al.obj1_attr1,
'||'    al.event_desc,
'||'    sr.req_type as request_num_type,
'||'    case
'||'      when sr.req_type = 0 then ''Access Request''
'||'      when sr.req_type = 1 then ''Access Removal Request''
'||'      when sr.req_type = 4 then ''Admin Access Change''
'||'      when sr.req_type = 5 then ''User Access Change''
'||'      when sr.req_type = 6 then ''Role Assign''
'||'      when sr.req_type = 8 then ''Role Removal''
'||'      when sr.req_type = 9 then ''Role Renewal''
'||'      when sr.req_type = 10 then ''Delegation Assign''
'||'      when sr.req_type = 12 then ''Delegation Removal''
'||'      when sr.req_type = 13 then ''Delegation Change''
'||'      when sr.req_type = 16 then ''Resource Removal''
'||'      when sr.req_type = 18 then ''Password Reset''
'||'      when sr.req_type = 19 then ''Password Change''
'||'      when sr.req_type = 20 then ''Password Reset (Target System)''
'||'      when sr.req_type = 21 then ''Generic''
'||'      when sr.req_type = 31 then ''OU Role Provisioning''
'||'      when sr.req_type = 32 then ''Account Suspend''
'||'      when sr.req_type = 33 then ''Account Restore''
'||'      when sr.req_type = 51 then ''Role Assignment (Admin)''
'||'      when sr.req_type = 52 then ''Role Removal (Admin)''
'||'      when sr.req_type = 53 then ''Role Amendment (Admin)''
'||'      when sr.req_type = 54 then ''OU Multi Role Assignement''
'||'      when sr.req_type = 56 then ''Time Multi Role Assign''
'||'      when sr.req_type = 57 then ''User Transfer''
'||'      when sr.req_type = 58 then ''Account Management''
'||'      when sr.req_type = 59 then ''Account Creation''
'||'      when sr.req_type = 61 then ''Delegation Renewal''
'||'      when sr.req_type = 63 then ''Role Provisioning''
'||'      when sr.req_type = 65 then ''Forked Access Request''
'||'      when sr.req_type = 70 then ''Entitlement Management''
'||'      when sr.req_type = 71 then ''Insert User''
'||'      when sr.req_type = 72 then ''Update User''
'||'      when sr.req_type = 73 then ''User Delete''
'||'      when sr.req_type = 77 then ''Entitlement Create''
'||'      when sr.req_type = 78 then ''Entitlement Update''
'||'      when sr.req_type = 79 then ''Entitlement Delete''
'||'      when sr.req_type = 80 then ''User Management''
'||'      when sr.req_type = 81 then ''Account Create''
'||'      when sr.req_type = 82 then ''Account Update''
'||'      when sr.req_type = 83 then ''Account Delete''
'||'      else cast ( sr.req_type as varchar(256) )
'||'    end request_type,
'||'    al.obj1_attr1 as request_num_status,
'||'    case
'||'      when al.obj1_attr1 = ''0'' then ''RAW''
'||'      when al.obj1_attr1 = ''1'' then ''Not authorizable''
'||'      when al.obj1_attr1 = ''2'' then ''Created''
'||'      when al.obj1_attr1 = ''3'' then ''Approved''
'||'      when al.obj1_attr1 = ''4'' then ''Suspended''
'||'      when al.obj1_attr1 = ''5'' then ''Rejected''
'||'      when al.obj1_attr1 = ''6'' then ''Performed''
'||'      when al.obj1_attr1 = ''7'' then ''Completed''
'||'      when al.obj1_attr1 = ''8'' then ''Failed''
'||'      when al.obj1_attr1 = ''9'' then ''Pending''
'||'      when al.obj1_attr1 = ''10'' then ''Escalated''
'||'      when al.obj1_attr1 = ''12'' then ''Partially authorizable''
'||'      when al.obj1_attr1 = ''13'' then ''Partially approved''
'||'      when al.obj1_attr1 = ''14'' then ''Partially performed''
'||'      when al.obj1_attr1 = ''15'' then ''Partially completed''
'||'      when al.obj1_attr1 = ''17'' then ''INCOMPATIBLE ON GEN''
'||'      when al.obj1_attr1 = ''19'' then ''INCOMPATIBLE ON MOD''
'||'      when al.obj1_attr1 = ''21'' then ''INCOMPATIBLE ON AUTH''
'||'      when al.obj1_attr1 = ''23'' then ''INCOMPATIBLE ON EXE''
'||'      when al.obj1_attr1 = ''24'' then ''WAITING FOR ROLE ADD TO OU''
'||'      when al.obj1_attr1 = ''25'' then ''END of WAITING FOR ROLE ADD TO OU''
'||'      when al.obj1_attr1 = ''55'' then ''Canceled''
'||'    end request_status,
'||'    al.obj1_attr3,
'||'    al.obj1_attr4,
'||'    al.target_attr5,
'||'    al.target_key_name
'||'from #swimschema#.request sr left outer join ( select * from #servschema#.audit_log al where al.module = ''ARM'' ) al on sr.id = al.obj1_key_id
'||'  where sr.id > ( select cast ( min ( al.cod_operation ) - 2 as number ) from #servschema#.audit_log al where al.module = ''ARM'' )
'||') req_au
'||'left outer join #swimschema#.s_user su on req_au.req_applicant = su.id
'||'left outer join #pmschema#.person ra on ra.code = su.userid
'||'left outer join #pmschema#.person ro on ro.code = req_au.operator_code
'||'left outer join #pmschema#.person rb on rb.code = req_au.target_key_name
'||'order by req_au.req_grp, req_au.req_id, req_au.event_date
';

  update R_QUERY_DATA set QUERY=varLob where R_QUERY=19;
  
  end;
/
commit;

declare
  varLob  CLOB;

begin
  varLob := 'SELECT distinct a.name          as SAP_SYSTEM_NAME,
'||'                itr.NAME        as SAP_ROLE_NAME,
'||'                itr.DESCRIPTION as SAP_ROLE_DESC,
'||'                itri.low        as INCOMP_LEVEL_LOW,
'||'                itri.medium     as INCOMP_LEVEL_MEDIUM,
'||'                itri.high       as INCOMP_LEVEL_HIGH,
'||'                itf.name        as ENTITLEMENT_TYPE
'||'  FROM #ccsschema#.entitlement        itr,
'||'       #ccsschema#.entitlement_family itf,
'||'       #ccsschema#.entitlement_incomp itri,
'||'       #ccsschema#.application        a,
'||'       #ccsschema#.environment        e
'||' where itr.family = itf.id
'||'   and lower ( itf.name ) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and itr.application = a.id
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and itr.id = itri.entitlement
'||'   and itri.environment = e.id
'||'   and e.working = 1
';

 update R_QUERY_DATA set QUERY=varLob where R_QUERY=126;
    commit; 
  end;
/

declare
  varLob  CLOB;

begin
  varLob := 'select a.name as SAP_SYSTEM_NAME,
'||'       it.name as SAP_ROLE_NAME,
'||'       it.description as SAP_ROLE_DESC,
'||'       pr.name as SAP_AUTHORIZATION_NAME,
'||'       pr.TRANSACTION_NAME as SAP_TRANSACTION_NAME,
'||'       ( tk.path || ''/'' || tk.name ) as ACTIVITY_NAME,
'||'       ( tk.id - cast ( ''#arcs_sod_code#'' as numeric ) ) as SOD_CODE,
'||'       itf.name  as ENTITLEMENT_TYPE
'||'  from #ccsschema#.entitlement           it,
'||'       #ccsschema#.entitlement_family    itf,
'||'       #ccsschema#.entitlement_flat_hier itpr,
'||'       #ccsschema#.entitlement           pr,
'||'       #ccsschema#.task_profile          tp,
'||'       #ccsschema#.task                  tk,
'||'       #ccsschema#.environment           e,
'||'       #ccsschema#.application           a
'||' where it.family = itf.id
'||'   and lower ( itf.name ) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and it.application = a.id
'||'   and a.id = pr.application
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and it.id = itpr.parent
'||'   and itpr.child = pr.id
'||'   and itpr.child_int_type = 1
'||'   and pr.id = tp.profile
'||'   and lower ( e.name ) = lower ( ''#environment_name#'' )
'||'   and e.id = tp.environment
'||'   and tp.environment = tk.environment
'||'   and tp.task = tk.id
'||'   and lower ( it.name ) like lower ( ''#sap_role_name#'' )
';

update R_QUERY_DATA set QUERY=varLob where R_QUERY=124;
    commit; 
	end;
/

declare
  varLob  CLOB;

begin
  varLob := 'SELECT distinct a.name   as SAP_SYSTEM_NAME,
'||'                itr.NAME as SAP_ROLE_NAME,
'||'                tr.name  as SAP_TRANSACTION_NAME,
'||'                itf.name  as ENTITLEMENT_TYPE
'||'  FROM #ccsschema#.entitlement        itr,
'||'       #ccsschema#.entitlement_family itf,
'||'       #ccsschema#.transactionrole    tr,
'||'       #ccsschema#.application        a
'||' where itr.family = itf.id
'||'   and lower ( itf.name ) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and a.id = itr.application
'||'   and itr.application = tr.application
'||'   and itr.id = tr.entitlement
'||'   and lower ( itr.name ) like lower ( ''#sap_role_name#'' )
';

  update R_QUERY_DATA set QUERY=varLob where R_QUERY=127;
    commit; 

end;
/

declare
  varLob  CLOB;

begin
  varLob := 'SELECT distinct a.name as SAP_SYSTEM_NAME,
'||'                itr.name as SAP_ROLE_NAME,
'||'                au.name as SAP_AUTHOBJ_NAME,
'||'                aoitr.field_name as SAP_FIELD_NAME,
'||'                aoitr.min_value as SAP_FIELD_MIN_VALUE,
'||'                aoitr.max_value as SAP_FIELD_MAX_VALUE,
'||'                itf.name  as ENTITLEMENT_TYPE
'||'  FROM #ccsschema#.entitlement        itr,
'||'       #ccsschema#.entitlement_family itf,
'||'       #ccsschema#.AO_entitlement     aoitr,
'||'       #ccsschema#.authobj            au,
'||'       #ccsschema#.application           a
'||' where itr.family = itf.id
'||'   and lower ( itf.name) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and a.id = itr.application
'||'   and itr.application = aoitr.application
'||'   and aoitr.application = au.application
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and itr.id = aoitr.entitlement
'||'   and au.id = aoitr.authobj
'||'   and lower ( itr.name ) like lower ( ''#sap_role_name#'' )
';

  update R_QUERY_DATA set QUERY=varLob where R_QUERY=128;
    commit; 
end;
/

declare
  varLob  CLOB;

begin
  varLob := 'select distinct app.name as SAP_SYSTEM_NAME,
'||'                ent.name as ENTITLEMENT_NAME,
'||'                ent.description as ENTITLEMENT_DESC,
'||'                case
'||'                  when ent.int_type = 1 then ''SAP Authorization''
'||'                  when ent.int_type = 2 and ri.family_id = 1 then ''SAP Role''
'||'                  when ent.int_type = 2 and ri.family_id = 2 then ''Collective Role''
'||'                  when ent.int_type = 2 and ri.family_id = 3 then ''Cluster Role''
'||'                  when ent.int_type = 2 and ri.family_id = 4 then ''Single Profile''
'||'				  when ent.int_type = 2 and ri.family_id = 5 then ''Collective Profile''
'||'                  when ent.int_type = 3 then ''Business Role''
'||'                end as ENTITLEMENT_TYPE,
'||'                pro.name as SAP_AUTHORIZATION_NAME,
'||'                dom.name as DOMAIN_NAME,
'||'                dom.description as DOMAIN_DESC,
'||'                t.name as ACTIVITY_NAME,
'||'                t.description as ACTIVITY_DESC,
'||'                r.name as RISK_NAME,
'||'                rt.name as RISK_TYPE,
'||'                ri.risk_severity as SEVERITY
'||'  from
'||'    (
'||'      select
'||'        ri.environment, ri.entity, ri.entity_type, ri.domain, ri.rem_under,
'||'        ri.rem_ok, ri.rem_over, ri.random_code, ri.risk, ri.task, ri.entitlement,
'||'        ri.profile, ri.risk_severity, ri.ume_list, pr.application, entf.id as family_id, entf.name as family_name
'||'      from
'||'        #ccsschema_tmp#.tmp_report_incomp ri,
'||'        #ccsschema#.entitlement       pr,
'||'        #ccsschema#.entitlement       ent
'||'        left outer join #ccsschema#.entitlement_family   entf
'||'        on ent.family = entf.id
'||'      where ri.profile = pr.id and ri.entity = ent.id
'||'    ) ri,
'||'       #ccsschema_tmp#.tmp_report_entitlement tmp_ent,
'||'       #ccsschema#.entitlement         ent,
'||'       #ccsschema#.application         app,
'||'       #ccsschema#.entitlement         pro,
'||'       #ccsschema#.domain              dom,
'||'       #ccsschema#.risk                r,
'||'       #ccsschema#.task                t,
'||'       #ccsschema#.risk_type           rt
'||' where ri.random_code = ''#random_code#''
'||'   and ri.entity_type = 1
'||'   and ri.entity = ent.id
'||'   and ent.id = tmp_ent.id
'||'   and tmp_ent.application = app.id
'||'   and ri.profile = pro.id
'||'   and ri.environment = dom.environment
'||'   and dom.environment = r.environment
'||'   and r.environment = rt.environment
'||'   and rt.environment = t.environment
'||'   and ri.task = t.id
'||'   and ri.domain = dom.id
'||'   and ri.risk = r.id
'||'   and r.risk_type = rt.id
'||'   and ri.family_id in ( 1, 2, 4, 5 )
'||'   and ent.int_type = 2
'||'   and lower ( app.name ) = lower ( ''#sap_system_name#'' )
';
  
  update R_QUERY_DATA set QUERY=varLob where R_QUERY=130;
    commit;

end;
/
