declare
  varLob  CLOB;

begin
  varLob := 'select a.name as SAP_SYSTEM_NAME,
'||'       it.name as ENTITLEMENT_NAME,
'||'       it.description as ENTITLEMENT_DESC,
'||'       pr.name as SAP_AUTHORIZATION_NAME,
'||'       pr.TRANSACTION_NAME as SAP_TRANSACTION_NAME,
'||'       ( tk.path || ''/'' || tk.name ) as ACTIVITY_NAME,
'||'       ( tk.id - cast ( ''#arcs_sod_code#'' as numeric ) ) as SOD_CODE,
'||'       itf.name  as ENTITLEMENT_TYPE
'||'  from #ccsschema#.entitlement           it,
'||'       #ccsschema#.entitlement_family    itf,
'||'       #ccsschema#.entitlement_flat_hier itpr,
'||'       #ccsschema#.entitlement           pr,
'||'       #ccsschema#.task_profile          tp,
'||'       #ccsschema#.task                  tk,
'||'       #ccsschema#.environment           e,
'||'       #ccsschema#.application           a
'||' where it.family = itf.id
'||'   and lower ( itf.name ) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and it.application = a.id
'||'   and a.id = pr.application
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and it.id = itpr.parent
'||'   and itpr.child = pr.id
'||'   and itpr.child_int_type = 1
'||'   and pr.id = tp.profile
'||'   and lower ( e.name ) = lower ( ''#environment_name#'' )
'||'   and e.id = tp.environment
'||'   and tp.environment = tk.environment
'||'   and tp.task = tk.id
'||'   and lower ( it.name ) like lower ( ''#entitlement_name#'' )
';

update R_QUERY_DATA set QUERY=varLob where R_QUERY=124;
    commit; 
	end;
/


declare
  varLob  CLOB;

begin
  varLob := 'SELECT distinct a.name   as SAP_SYSTEM_NAME,
'||'                itr.NAME as ENTITLEMENT_NAME,
'||'                tr.name  as SAP_TRANSACTION_NAME,
'||'                itf.name  as ENTITLEMENT_TYPE
'||'  FROM #ccsschema#.entitlement        itr,
'||'       #ccsschema#.entitlement_family itf,
'||'       #ccsschema#.transactionrole    tr,
'||'       #ccsschema#.application        a
'||' where itr.family = itf.id
'||'   and lower ( itf.name ) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and a.id = itr.application
'||'   and itr.application = tr.application
'||'   and itr.id = tr.entitlement
'||'   and lower ( itr.name ) like lower ( ''#entitlement_name#'' )
';

  update R_QUERY_DATA set QUERY=varLob where R_QUERY=127;
    commit; 

end;
/


declare
  varLob  CLOB;

begin
  varLob := 'SELECT distinct a.name as SAP_SYSTEM_NAME,
'||'                itr.name as ENTITLEMENT_NAME,
'||'                au.name as SAP_AUTHOBJ_NAME,
'||'                aoitr.field_name as SAP_FIELD_NAME,
'||'                aoitr.min_value as SAP_FIELD_MIN_VALUE,
'||'                aoitr.max_value as SAP_FIELD_MAX_VALUE,
'||'                itf.name  as ENTITLEMENT_TYPE
'||'  FROM #ccsschema#.entitlement        itr,
'||'       #ccsschema#.entitlement_family itf,
'||'       #ccsschema#.AO_entitlement     aoitr,
'||'       #ccsschema#.authobj            au,
'||'       #ccsschema#.application           a
'||' where itr.family = itf.id
'||'   and lower ( itf.name) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and a.id = itr.application
'||'   and itr.application = aoitr.application
'||'   and aoitr.application = au.application
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and itr.id = aoitr.entitlement
'||'   and au.id = aoitr.authobj
'||'   and lower ( itr.name ) like lower ( ''#entitlement_name#'' )
';

  update R_QUERY_DATA set QUERY=varLob where R_QUERY=128;
    commit; 
end;
/


declare
  varLob  CLOB;

begin
  varLob := 'SELECT distinct a.name          as SAP_SYSTEM_NAME,
'||'                itr.NAME        as ENTITLEMENT_NAME,
'||'                itr.DESCRIPTION as ENTITLEMENT_DESC,
'||'                itri.low        as INCOMP_LEVEL_LOW,
'||'                itri.medium     as INCOMP_LEVEL_MEDIUM,
'||'                itri.high       as INCOMP_LEVEL_HIGH,
'||'                itf.name        as ENTITLEMENT_TYPE
'||'  FROM #ccsschema#.entitlement        itr,
'||'       #ccsschema#.entitlement_family itf,
'||'       #ccsschema#.entitlement_incomp itri,
'||'       #ccsschema#.application        a,
'||'       #ccsschema#.environment        e
'||' where itr.family = itf.id
'||'   and lower ( itf.name ) IN ( lower( ''Single Profile'' ), lower( ''SAP Role'' ))
'||'   and itr.application = a.id
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and itr.id = itri.entitlement
'||'   and itri.environment = e.id
'||'   and e.working = 1
';

 update R_QUERY_DATA set QUERY=varLob where R_QUERY=126;
    commit; 
  end;
/


declare
  varLob  CLOB;
 
begin 
  varLob := 'select t.id              as auditlog_id,
'||'       t.parent_id       as auditlog_parentid,
'||'        t.module          as auditlog_module,
'||'        t.submodule       as auditlog_submodule,
'||'        t.hash            as auditlog_hash,
'||'        t.signature       as auditlog_signature,
'||'        t.operator_code   as auditlog_operator_code,
'||'        t.operator_key    as auditlog_operator_key,
'||'        t.event_id        as auditlog_eventid,
'||'        t.event_desc      as auditlog_desc,
'||'        t.event_desc_long as auditlog_desc_long,
'||'        t.severity        as auditlog_severity,
'||'        t.cod_operation   as auditlog_cod_operation,
'||'        TO_CHAR(t.event_date ,''Mon DD, YYYY, HH:MI:SS PM'') as auditlog_event_date,
'||'        t.event_millis    as auditlog_event_millis,
'||'        TO_CHAR(t.audit_date, ''Mon DD, YYYY, HH:MI:SS PM'') as auditlog_date,
'||'        t.target_type     as auditlog_target_type,
'||'        t.target_key_id   as auditlog_target_keyid,
'||'        t.target_key_name as auditlog_target_keyname,
'||'        t.target_attr1    as auditlog_attr1,
'||'       t.target_attr2    as auditlog_attr2,
'||'       t.target_attr3    as auditlog_attr3,
'||'       t.target_attr4    as auditlog_attr4,
'||'       t.target_attr5    as auditlog_attr5,
'||'       t.obj1_type       as auditlog_obj1_type,
'||'       t.obj1_key_id     as auditlog_obj1_keyid,
'||'       t.obj1_key_name   as auditlog_obj1_keyname,
'||'       t.obj1_attr1      as auditlog_obj1_attr1,
'||'       t.obj1_attr2      as auditlog_obj1_attr2,
'||'       t.obj1_attr3      as auditlog_obj1_attr3,
'||'       t.obj1_attr4      as auditlog_obj1_attr4,
'||'       t.obj1_attr5      as auditlog_obj1_attr5,
'||'       t.obj2_type       as auditlog_obj2_type,
'||'       t.obj2_key_id     as auditlog_obj2_keyid,
'||'       t.obj2_key_name   as auditlog_obj2_keyname,
'||'       t.obj2_attr1      as auditlog_obj2_attr1,
'||'       t.obj2_attr2      as auditlog_obj2_attr2,
'||'       t.obj2_attr3      as auditlog_obj2_attr3,
'||'       t.obj2_attr4      as auditlog_obj2_attr4,
'||'       t.obj2_attr5      as auditlog_obj2_attr5,
'||'       t.data            as auditlog_data
'||'  from #servschema#.audit_log t
'||' where t.audit_date
'||'     between to_timestamp (''#START_DATE# '', ''#ideas_simpledate# hh24:mi:ss,ff6'')
'||'     and to_timestamp (''#END_DATE# '', ''#ideas_simpledate# hh24:mi:ss,ff6'')
'||'	 ORDER BY t.audit_date DESC 
'||'	 FETCH FIRST 250000 ROWS only
';
 update R_QUERY_DATA set QUERY=varLob where R_QUERY=21;
    commit; 
  end;
/